new.display <- function(w, h, rgb=TRUE, ...) {
    .lastDisplay <<- .Call("RVT_create_display", w, h, rgb, PACKAGE="videoTools")
}

update.videodisplay <- function(object, r, g, b, ...) {
    if (missing(g))
	.Call("RVT_update_display_mono", object, r, PACKAGE="videoTools")
    else if (missing(b))
	.Call("RVT_update_display_yuy2", object, r, g, NULL, PACKAGE="videoTools")
    else
	.Call("RVT_update_display_rgb", object, r, g, b, PACKAGE="videoTools")
}

"==.videodisplay" <- function(e1, e2) {
    i1 <- .Call("RVT_get_display_info", e1, PACKAGE="videoTools")
    i2 <- .Call("RVT_get_display_info", e2, PACKAGE="videoTools")
    i1[3] == i2[3]
}
    

close.videodisplay <- function(con, ...) {
    if (exists(".lastDisplay") && con == .lastDisplay)
        rm(".lastDisplay",inherits=TRUE)
    .Call("RVT_close_display", con, PACKAGE="videoTools")
}

print.videodisplay <- function(x, ...) {
    x <- .Call("RVT_get_display_info", x, PACKAGE="videoTools")
    cat("videodisplay#",x[3],": ",x[1]," x ",x[2]," (",c("RGB","YUV")[x[4]+1],")\n",sep='')
}
