\name{fourcc}
\alias{int2fourcc}
\alias{fourcc2int}
\title{
  Fourcc format identifier conversions
}
\description{
  \code{Functions for manipulation of fourcc format identifiers}
}
\usage{
fourcc2int(fcc)
int2fourcc(iv)
}
\arguments{
  \item{fcc}{string value defining a fourcc format}
  \item{iv}{integer value defining a fourcc format}
}
\value{
  converted value of the fourcc format.
}
\details{
  \code{fourcc2int} convert string representation to integer
  representation, \code{int2fourcc} does the inverse.

  Non-literal conversion is performed for "RGB32", "RGB24", "RGB16",
  "BGR32", "BGR24" and "BGR16" formats only. The validity of a specific
  format is not verified.
}
%\seealso{
%}
\examples{
sprintf("\%08x",fourcc2int("RGB32"))
int2fourcc(0x32595559)
}
\keyword{interface}
