#import <Cocoa/Cocoa.h>
#import <QuartzCore/QuartzCore.h>
#import <QuickTime/QuickTime.h>

#include <sys/types.h>
#include <stdint.h>

@interface VideoView : NSOpenGLView
{
	//Cocoa
	NSWindow *window;
	NSOpenGLContext *glContext;
	NSEvent *event;
	
	NSRect screen_frame;
	NSScreen *screen_handle;

	int did;
	
	//image
	unsigned char *image_data;
	uint32_t image_width;
	uint32_t image_height;
	uint32_t image_depth;
	uint32_t image_bytes;
	uint32_t image_format;
	
	int isFullscreen;
	int isOntop;
	int isRootwin;
	float monitor_aspect; // FIXME
	int vo_keepaspect;
	float movie_aspect;
	float old_movie_aspect;
	
	//CoreVideo
	CVPixelBufferRef currentFrameBuffer;
	CVOpenGLTextureCacheRef textureCache;
	CVOpenGLTextureRef texture;
	NSRect textureFrame;
	
	OSType pixelFormat;

    GLfloat     lowerLeft[2]; 
    GLfloat lowerRight[2]; 
    GLfloat upperRight[2];
    GLfloat upperLeft[2];
	
	BOOL mouseHide;
	float winSizeMult;
	//menu command id
	NSMenuItem *kQuitCmd;
	NSMenuItem *kHalfScreenCmd;
	NSMenuItem *kNormalScreenCmd;
	NSMenuItem *kDoubleScreenCmd;
	NSMenuItem *kFullScreenCmd;
	NSMenuItem *kKeepAspectCmd;
	NSMenuItem *kAspectOrgCmd;
	NSMenuItem *kAspectFullCmd;
	NSMenuItem *kAspectWideCmd;
	NSMenuItem *kPanScanCmd;
	
	
}

- (BOOL) acceptsFirstResponder;
- (BOOL) becomeFirstResponder;
- (BOOL) resignFirstResponder;

- (unsigned int) width;
- (unsigned int) height;
- (unsigned char*) imageBuffer;
- (unsigned int) format;
- (int) viewID;

	//window & rendering
- (id) config;
- (void) prepareOpenGL;
- (void) render;
- (void) reshape;
- (void) setCurrentTexture;
- (void) drawRect: (NSRect *) bounds;

	//vo control
- (void) fullscreen: (BOOL) animate;
- (void) ontop: (BOOL) flag;
- (void) rootwin: (BOOL) flag;

	//menu
- (void) initMenu;
- (void) menuAction:(id)sender;

	//event
- (void) keyDown: (NSEvent *) theEvent;
- (void) mouseMoved: (NSEvent *) theEvent;
- (void) mouseDown: (NSEvent *) theEvent;
- (void) rightMouseDown: (NSEvent *) theEvent;
- (void) otherMouseDown: (NSEvent *) theEvent;
- (void) scrollWheel: (NSEvent *) theEvent;
- (void) mouseEvent: (NSEvent *) theEvent;
- (void) check_events;
@end
